{****************************************************}
{*             SuperCom 4.3                         *}
{*                                                  *}
{* Windows NT                                       *}
{* Copyright (c) 1991,2000 by ADONTEC Ltd.          *}
{****************************************************}

unit SuperCom;

interface

uses Windows;

{$DEFINE _OS_NT_}

const DLL_Path = 'SUPERCOM.DLL'; { Name of SuperCom DLL }


const COM_1   =  0;
      COM_2   =  1;
      COM_3   =  2;
      COM_4   =  3;
      COM_5   =  4;
      COM_6   =  5;
      COM_7   =  6;
      COM_8   =  7;
      COM_9   =  8;
      COM_10  =  9;
      COM_11  = 10;
      COM_12  = 11;
      COM_13  = 12;
      COM_14  = 13;
      COM_15  = 14;
      COM_16  = 15;
      COM_17  = 16;
      COM_18  = 17;
      COM_19  = 18;
      COM_20  = 19;
      COM_21  = 20;
      COM_22  = 21;
      COM_23  = 22;
      COM_24  = 23;
      COM_25  = 24;
      COM_26  = 25;
      COM_27  = 26;
      COM_28  = 27;
      COM_29  = 28;
      COM_30  = 29;
      COM_31  = 30;
      COM_32  = 31;
      COM_33  = 32;
      COM_34  = 33;
      COM_35  = 34;
      COM_36  = 35;

      LAST_COM        = COM_36;

      MAX_ISR         = 14;
      MAX_COM         = 36;

      LAST_RS232_COM  = COM_10; { RS232 Part 1 (Version 2 compatibel) }
      FIRST_RS232_COM2= COM_33; { RS232 Part 2 }
      LAST_RS232_COM2 = COM_36; { RS232 Part 2 }
      LAST_DIGI_COM   = COM_32; { DigiCHANNEL PC/X }
      LAST_MULTI_COM  = COM_8;  { AST, ARNET }
      LAST_STAR_COM   = COM_32; { StarGate or Hostess }

{$IFDEF _OS_NT_}
		   (* Time constants in ms  *)
      SEC0_05          =    50;   (*  50 ms *)
      SEC0_1           =   100;   (* 100 ms *)
      SEC0_2           =   200;
      SEC0_3           =   300;
      SEC0_4           =   400;
      SEC0_5           =   500;   (* 1 sec *)
      SEC_1            =  1000;
      SEC_2            =  2000;
      SEC_3            =  3000;
      SEC_4            =  4000;
      SEC_5            =  5000;
      SEC_10           = 10000;
      SEC_20           = 20000;
      SEC_30           = 30000;
      SEC_40           = 40000;
      SEC_50           = 50000;
      SEC_60           = 60000;   (* 1 min *)
{$ELSE}

      Sec0_05          =    1;  {   50 ms  }
      Sec0_1           =    2;  {  100 ms  }
      Sec0_3           =    6;  {  300 ms  }
      Sec0_5           =    9;  {  500 ms  }
      Sec_1            =   18;  {    1 sec }
      Sec_2            =   37;  {    2 sec }
      Sec_3            =   55;  {    3 sec }
      Sec_4            =   73;  {    4 sec }
      Sec_5            =   91;  {    5 sec }
      Sec_10           =  182;  {   10 sec }
      Sec_20           =  364;  {   20 sec }
      Sec_30           =  546;  {   30 sec }
      Sec_60           = 1092;  {    1 min }
{$ENDIF}

      SOH   = #01;
      STX   = #02;
      BREAK = #03;
      EOT   = #04;
      ACK   = #06;
      BEL   = #07;
      BS    = #08;
      TAB   = #09;
      LF    = #10;
      FF    = #12;
      CR    = #13;
      DC1   = #17;
      DC3   = #19;
      NAK   = #21;
      CAN   = #24;
      ESC   = #27;
      XON   = #17;
      XOFF  = #19;

 			     { function Result Codes, ComResult}

      scOk                 =  0;    { OK }
      scInvPort            =  1;    { Invalid Port, Port not connected }
      scNoUserBreak        =  2;    { UserBreak-Future not installed   }
      scNoPMInit           = 10;    { Cannot Init. Protected Mode Data }
      scNoPMReset          = 11;    { Cannot Reset Protected Mode Data }
      scInvBaud            = 12;    { Baudrate not supported by driver }
      scInvFunc            = 13;    { Invalid function.                }

      IER_ENABLE_RX        = $01;   { ISR Mode}
      IER_ENABLE_TX        = $02;
      IER_ENABLE_ERROR     = $04;
      IER_ENABLE_MODEM     = $08;
      IER_ENABLE_ALL       = $0F;   { Default }

      SIGNAL_DTR           = $01;   { Com Drive Signals }
      SIGNAL_RTS           = $02;
      SIGNAL_OUT2          = $08;
      SIGNAL_DTR_OUT2      = $09;
      SIGNAL_RTS_OUT2      = $0A;
      SIGNAL_DTR_RTS       = $03;
      SIGNAL_DTR_RTS_OUT2  = $0B;
      SIGNAL_LOOP          = $10;

      SIGNAL_NONE          = $00;   { Flow Check Signals }
      SIGNAL_CTS           = $10;
      SIGNAL_DSR           = $20;
      SIGNAL_DSR_CTS       = $30;
      SIGNAL_XON           = $80;
      SIGNAL_DSR_CTS_XON   = $B0;

      RX_READY             = $01;   { Bits Of LineStatusReg }
      OVERRUN_ERROR        = $02;
      PARITY_ERROR         = $04;
      FRAMING_ERROR        = $08;
      BREAK_DETECT         = $10;
      TX_READY             = $20;

      DELTA_CTS            = $01;   { Bits Of ModemStatusReg }
      DELTA_DSR            = $02;
      DELTA_RI             = $04;
      DELTA_DCD            = $08;
      CLEAR_TO_SEND        = $10;
      DATA_SET_READY       = $20;
      RING_INDICATOR       = $40;
      DATA_CARRIER_DETECT  = $80;

      { On Init and after Reset signals }
      AR_DEFAULT           = $00;   { leave as found  }
      AR_ENABLE_DTR        = $01;   { enable the DTR  }
      AR_ENABLE_RTS        = $02;   { enable the RTS  }
      AR_DISABLE_DTR       = $04;   { disable the DTR }
      AR_DISABLE_RTS       = $08;   { disable the RTS }

      brkChain = 0;
      brkDiscard = 1;
      brkNow = 2;

      MAXMODEMRESULT=80;

      HAYES_INIT_STRING='ATE0L1M0Q0V1&C1&D2&S1S0=0';


      	{ result of ComPortPresent }
      PORT_UNAVAILABLE       =0;
      PORT_AVAILABLE_READY   =1;
      PORT_AVAILABLE_BUSY    =2;


{$IFDEF _OS_NT_}
      EV_RXCHAR     = $0001; { Any Character received              }
      EV_RXFLAG     = $0002; { Received event character            }
      EV_TXEMPTY    = $0004; { Transmit Queue Empty                }
      EV_CTS        = $0008; { CTS changed state                   }
      EV_DSR        = $0010; { DSR changed state                   }
      EV_DCD        = $0020; { DCD changed state                   }
      EV_RLSD       = $0020; { RLSD changed state                  }
      EV_BREAK      = $0040; { BREAK received                      }
      EV_ERR        = $0080; { Line status error occurred          }
      EV_RI         = $0100; { Ring signal detected                }
      EV_RING       = $0100; { Ring signal detected                }
      EV_RX80FULL   = $0400; { Receive buffer is 80 percent full   }


      ZEROEVENTMASK = $FFFFFFFF; { Value to clear the event mask using ComGetSetEventMask }
      STDEVENTMASK  = EV_RXCHAR or EV_TXEMPTY or EV_CTS or EV_DSR or EV_RLSD
                      or EV_BREAK or EV_ERR or EV_RING or EV_RX80FULL;
{$ENDIF}


           { bits 0..31 of protocol status word }
      PROTOCOL_STATUS_NULL     = $FFFF; { only get status }
      PROTOCOL_STATUS_GET      = $FFFF; { only get status }
      PROTOCOL_STATUS_STOP     = $0001; { stop protocol   }
      PROTOCOL_STATUS_RUNNING  = $0002; { protocol is still running }
      PROTOCOL_STATUS_VALUE    = $0004; { }
      PROTOCOL_STATUS_DELAY    = $0008; { }

            { IRQ Lines }
      IRQ0 = 0;
      IRQ1 = 1;
      IRQ2 = 2;
      IRQ3 = 3;
      IRQ4 = 4;
      IRQ5 = 5;
      IRQ6 = 6;
      IRQ7 = 7;
      IRQ8 = 8;
      IRQ9 = 9;
      IRQ10=10;
      IRQ11=11;
      IRQ12=12;
      IRQ13=13;
      IRQ14=14;
      IRQ15=15;

				       { Vectors }
      VEC1 = IRQ4+8;                      { Vector COM1/IRQ4 }
      VEC2 = IRQ3+8;                      { Vector COM2/IRQ3 }

      THRESHOLD01 = $00;               { 16550 FIFO Threshold }
      THRESHOLD04 = $40;
      THRESHOLD08 = $80;
      THRESHOLD14 = $C0;

      evCHG_MODEM_STATUS = $01;   { Events for ComGetEvent }
      evTHREMPTY         = $02;
      evRXRDY            = $04;
{$IFDEF _OS_NT_}
      evEXCEPTION        = $08;
{$ELSE}
      evEXCEPTION        = $06;
{$ENDIF}

      evCHAR_RECEIVED    = $0001;
      evLAST_CHAR_SENT   = $0004;
      evCTS_CHANGED      = $0008;
      evDSR_CHANGED      = $0010;
      evDCD_CHANGED      = $0020;
      evBREAK_DETECTED   = $0040;
      evERROR_OCCURED    = $0080;
      evRI_DETECTED      = $0100;
      evRI_CHANGED       = $0200;

			{ Reasons in AH within UserRXProc }
      REASON_RXREADY     = $00;
      REASON_TXEMPTY     = $01;
      REASON_MSTATUS     = $02;
      REASON_ERROR       = $03;
      REASON_USER        = $20;  { user events schould be > REASON_USER }

                       { ComRS485 Action }
      RS485DISABLE  = 0;
      RS485ENABLE   = 1;
      RS485STATUS   = 2;

      flRS485       = 1; { special flag }

			{ supported protocols }
      PROTOCOL_ASCII        = 0;
      PROTOCOL_XMODEM       = 1;
      PROTOCOL_XMODEMCRC    = 2;
      PROTOCOL_YMODEM       = 3;
      PROTOCOL_YMODEMBATCH  = 4;
      PROTOCOL_ZMODEM       = 5;
      PROTOCOL_USER         =64;    { user protocols: PROTOCOL_USER + 1 etc. }

{$IFDEF _OS_NT_}
      SC_MAXPATH = 512;

      _MAX_PATH   =260;
      _MAX_DRIVE  =  3;
      _MAX_DIR    =256;
      _MAX_FNAME  =256;
      _MAX_EXT    =256;
{$ELSE}
      SC_MAXPATH = 128;

      _MAX_PATH   =80;
      _MAX_DRIVE  = 3;
      _MAX_DIR    =66;
      _MAX_FNAME  = 9;
      _MAX_EXT    = 5;
{$ENDIF}
			 { SuperCom error codes. Other codes are the DOS error codes. }
      ERRTIMEOUT   =(-9999);
      ERRCANCELED  =(-9998);
      ERRBADLINE   =(-9997);
      ERRGOTCAN    =(-9996);
      ERRNOHEADER  =(-9995);
      ERRBADSTRUCT =(-9994);
      ERRNOMEMORY  =(-9993);

			 { definitions used inside the  info function }
      acTXING           = 0;           { transmitting package }
      acRXING           = 1;           { receiving package }
      acUSERBREAK       = 2;           { Ctrl-Break }
      acSYN             = 3;           { Synchronize }
      acRETRY           = 4;           { Retry }
      acFILENAME        = 5;           { receiving Filename }
      acRXFIN           = 6;           { succesfully rx }
      acTXFIN           = 7;           { succesfully tx }
      acFILEDATA        = 8;           { on tx request file data }
      acCONNECT_INFO    =32;           { info from RS_Connect }
      acCONNECT_OK      =33;           { from RS_Connect CONNECT succeed }
      acCONNECT_FAILED  =34;           { from RS_Connect CONNECT failed }

      acUSER           =128;           { user actions: acUSER + 1 etc. }


      CONNECT_INFO_PERIOD = SEC_1;     { RS_Connect, info period }


      WAITACK         = SEC_10;  { Waiting period for Acknowledge }
      WAITONECHAR     = SEC_1;   { Waiting period for one char }
      WAITHEADER      = SEC_5;   { Waiting period for Header }
      WAITSTARTHEADER = SEC_60;  { Waiting period for ZRINIT Header }

				 { Protocol Info }

      MAXRETRYS  = 5;          { times }
      NAKDELAY   = 1;          { 1 ms }

  { return codes used in Info functions }
      infBREAK           =  0; { Break protocol }
      infCONTINUE        =  1; { continue protocol }
      infZRECOVERY       =  2; { start ZMODEM crash recovery }
      infCONTSESSION     =  3; { continue ZMODEM session (TXFile)    }
                               { Info proc returns infCONTSESSION    }
                               { after acTXFIN if more files are to  }
                               { be sent in the same ZMODEM session  }


(* These defines are used by ComInit.                  *)
(* If you want to change the length of the buffers     *)
(* change these constants and build the library again  *)
       BUFFERSIZE_RX   = 8192;   (* RX queue buffer len *)
       BUFFERSIZE_TX   = 4096;   (* TX queue buffer len *)


type
      TDWORD   = LongInt;
{$IFDEF _OS_NT_}
      TSYSTIME = TDWORD;
{$ELSE}
      TSYSTIME = WORD;
{$ENDIF}
      LPSTRING = PCHAR;

type TFDATE = record
                Year:Word;  { e.g. 1994 }
                Month:Word; { 1..12   }
                Day:Word;   { 1..31   }
                Hour:Word;  { 0..23   }
                Min:Word;   { 0..59   }
                Sec:Word;   { 0..59   }
	            end;

type TFDATA = record                (*21.4.1995*)
                FileName :array[0..SC_MAXPATH-1] of Char;   { file name }
                Protocol :Word ;              { type of protocol }
                FileSize :LONGINT;            { file length }
                FileDate :TFDATE;             { file date }
                ProtFlags:TDWORD;             { flags for ZMODEM etc. }
                Flags2   :TDWORD;             { flags currently not used }
              end;
     PFDATA = ^TFDATA;

 { Protocol Flags used in FData.ProtFlags }
 { 0x0000 - 0x02FF reserved for ZMODEM    }
const FLAG_ZMODEM_FDX    = $0001;  { CANFDX   0x01 }
      FLAG_ZMODEM_OVIO   = $0002;  { CANOVIO  0x02 }
      FLAG_ZMODEM_CRC32  = $0020;  { CANFC32  0x20 }

type  TBufDir = (Dir_Inc, Dir_Out);
      TXBuffer= array[1..128] of Char;

      TBuffer = record
            	    BufPtr  :Pointer;
          		    BufLen  :Word;
          		    BufCount:Word;
          		    WrPtr   :Word;
          	  	  RdPtr   :Word;
	              end;

{$IFDEF _OS_NT_}

      SHORT = -32768 .. 32767;

      TDCBINFO = TDCB;

      TSaveState = record
                     ComInfo:TDCBINFO;
                     CommTimeouts:TCOMMTIMEOUTS;
                     EventMask:TDWORD;
	                 end;

      PSaveState = ^TSaveState;

      TComData = record
		               hCom        :THANDLE;
                   fXON        :BOOLEAN;
                   _DTR        :BYTE;
                   _RTS        :BYTE;
                   FlowControl :BYTE;
		               UserCount   :WORD;
		               Result      :WORD;
		               ErrorState  :BYTE;
		               ModemDelta  :BYTE;
                   Res         :BYTE;
		               Flags       :BYTE;
                   nTimerId    :TDWORD;
		               Process     :THANDLE;
                   SaveState   :TSaveState;
                   Userdata    :array[0..15] of Byte;
                 end;
{$ELSE}
      TSaveState = record
		                 BaudLo   :Byte;
		                 BaudHi   :Byte;
		                 LCRegData:Byte;
		                 MCRegData:Byte;
		                 IERegData:Byte;
		                 Spare    :Byte;
	                 end;

      TComData = record
                   XCom        :Word;
                   IOReg       :Word;
             		   IEReg       :Word;
            		   IIReg       :Word;
            		   LCReg       :Word;
            		   MCReg       :Word;
             		   LSReg       :Word;
             		   MSReg       :Word;
            		   ErrorState  :Byte;
            		   ModemState  :Byte;

            		   Vec         :Pointer;
             		   LineErrProc :Pointer;
                   InBuffer    :TBuffer;
            		   OutBuffer   :TBuffer;
            		   IRQ         :Byte;
            		   IRQVec      :Byte;

             		   Baud        :LongInt;
            		   DataBits    :Byte;
             		   StopBits    :Byte;
            		   Parity      :Char;

             		   Mode        :Byte;
            		   XON         :Boolean;
            		   DoXON       :Boolean;
             		   XONLimit    :Word;
            		   XOFFLimit   :Word;
            		   Queue       :Byte;
            		   FlowControl :Byte;
            		   XONChar     :Char;
             		   XOFFChar    :Char;
             		   Event       :Byte;
             		   Flags       :Byte;
                   Result      :Word;
             		   SaveState   :TSaveState;
            		   UserMXProc  :Pointer;
            		   UserRXProc  :Pointer;
            		   UserTXProc  :Pointer;
                   Userdata    :array[0..15] of Byte;
           		   end;
{$ENDIF}
      PComData = ^TComData;

type TSCRPOS = record
	               X:SHORT;
                 Y:SHORT;
               end;
     PSCRPOS =^TSCRPOS;


type  TInfoProc = function (Com:Byte; Action:WORD; Data:TDWORD; FileDate:PFDATA):Integer;   stdcall;

      PUSEREVENTPROC = function (Com:Byte; SComEvent:TDWORD):TDWORD; stdcall;

      TComInt = object
                     _Com:Byte;
                     function GetCom:Byte; virtual;
                     function ComGetVersion:Word; virtual;
                     constructor ComInit (ComPort:Byte);
                     constructor ComInithCom (ComPort:Byte; hCom:THANDLE);
                     function ComGethCom:THANDLE; virtual;
                     function ComGetSetEventProc(EventProc:PUSEREVENTPROC):PUSEREVENTPROC;  virtual;
                     procedure ComSetBufSize (RxBufferSize:TDWORD; TxBufferSize:TDWORD); virtual;
                     function ComResult:Word; virtual;
                     procedure ComSaveState;  virtual;
                     procedure ComSaveStateEx(var SaveState:TSAVESTATE); virtual;
                     procedure ComRestoreState(var SaveState:TSAVESTATE); virtual;
                     procedure ComXCHGState(var CurState:TSAVESTATE; var NewState:TSAVESTATE); virtual;
                     procedure ComSetState (NewBaud:LongInt;
                                            NewDataBits:Byte;
		                                        NewStopBits:Byte;
                                            NewParity:Char;
                                            NewFlow:Byte); virtual;
                     procedure ComSetStateEx(NewBaud:LongInt;
	                                           NewDataBits:Byte;
		                                         NewStopBits:Byte;
	                                           NewParity:Char;
		                                         NewFlow:Byte;
                                             SignalState:Byte); virtual;
                     procedure ComSetBaudRate(NewBaud:LongInt); virtual;
                     function ComGetBaudRate:LongInt; virtual;
                     function ComGetMaxBaudRate:LongInt; virtual;
                     procedure ComReset; virtual;
                     procedure ComResetEx(SignalState:Byte); virtual;
                     procedure ComSetXONXOFFChars (NewXONChar, NewXOFFChar:Char); virtual;
                     function ComGetXONXOFFChars:Word; virtual;
                     procedure ComSetXONState(State:Boolean); virtual;
                     function ComGetEvent:Byte;  virtual;
                     function ComGetEventEx:Word; virtual;
                     function ComPeekByte (Bofs:Byte):Byte; virtual;
                     function ComPeekWord (Bofs:Byte):Word; virtual;
                     function ComPeekLong (Bofs:Byte):TDWORD; virtual;
                     procedure ComPokeByte (Bofs:Byte; Data:Byte); virtual;
                     procedure ComPokeWord (Bofs:Byte; Data:Word); virtual;
                     procedure ComPokeLong (Bofs:Byte; Data:TDWORD); virtual;
                     function ComRead  (var RCh:Char):Boolean; virtual;
                     function ComWrite (SCh:Char):Boolean;  virtual;
                     function ComKickOut (SCh:Char):Boolean; virtual;
                     function ComKickOutXOFF:Boolean; virtual;
                     function ComKickOutXON:Boolean; virtual;
                     function ComBufSize(BufDir:TBufDir):TDWORD; virtual;
                     function ComBufCount (BufDir:TBufDir):TDWORD; virtual;
                     function ComBufFull  (BufDir:TBufDir):Boolean; virtual;
                     function ComBufEmpty (BufDir:TBufDir):Boolean; virtual;
                     procedure ComBufClear(BufDir:TBufDir); virtual;
                     procedure ComSetFlow  (Flow:Byte); virtual;
                     function ComGetFlow:Byte; virtual;
                     procedure ComEnableTX; virtual;
                     function  ComUngetChar (SCh:Char):Boolean; virtual;
                     function  ComSpyChar (var RCh:Char):Boolean; virtual;
{##18.12.1999

NOTE: Parameter SpyPos is
in SuperCom 32bit data relative e.g. 0 to BufCount-1
in SuperCom 16bit buffer absolute e.g. 0 to BufSize

The following is true for the SuperCom 32 bit version only.
COMSWBUFCOUNT returns only the amount of data stored in the SuperComs buffer.
Any data stored in a possible hardware buffer cannot be modified.
}

                     function ComSpyCharEx (var RCh:Char; BufDir:TBufDir; SpyPos:Word):Boolean; virtual;
                     function ComSwapChar (BufDir:TBufDir; SpyPos:Word; NewCh:Char):Char; virtual;
                     function COMSWBUFCOUNT(BufDir:TBufDir):Word; virtual;
                     function ComGetSysTime:TSYSTIME; virtual;
                     function ComGetElapsedTime (Start:TSYSTIME):TSYSTIME; virtual;
                     function ComModemState :Byte;   virtual;
                     function ComLineState  :Byte;   virtual;
                     function ComXONState   :Boolean;virtual;
                     procedure ComDTROn ; virtual;
                     procedure ComRTSOn ; virtual;
                     procedure ComDTROff; virtual;
                     procedure ComRTSOff; virtual;
                     procedure ComBreakOn; virtual;
                     procedure ComBreakOff;virtual;
                     function ComGetMCReg :Byte; virtual;
                     procedure ComPutMCReg (Val:Byte); virtual;
                     procedure ComSetSCResult(Res:Word); virtual;
                     function ComFIFOEnabled :Boolean; virtual;
                     function ComDisableFIFO :Boolean; virtual;
                     function ComEnableFIFO (Threshold:Byte):Boolean; virtual;
                     function  ComGetIRQVec(IRQ:Byte):Byte; virtual;
                     function  ComValid(Com:Byte):Boolean; virtual;
                     function ComRS485 (Action:Byte):Boolean; virtual;

                      {##02.03.1998}
                     procedure ComSetCOMName (szNewCOMName:PCHAR); virtual;
                     procedure ComSetRIQuard(State:Boolean); virtual;
                     procedure ComSetRIGuard(State:Boolean); virtual;
                     function ComGetSetEventMask (dwNewEventMask:TDWORD;
                                                 cEventChar:Char):TDWORD; virtual;
                     function ComHWBufSize (BufDir:TBufDir):TDWORD; virtual;
                     function ComHWBufCount (BufDir:TBufDir):TDWORD; virtual;
                     function ComGetProcess:THANDLE; virtual;
                     function ComPortPresent(Com:Byte):WORD; virtual;
                     procedure ComEnterCritSec; virtual;
                     procedure ComLeaveCritSec; virtual;
                     procedure ComEnterCritPortSec; virtual;
                     procedure ComLeaveCritPortSec;  virtual;
                     procedure ComOpen (InBuf:POINTER; InLen:Word;
			                                  OutBuf:POINTER; OutLen:Word);  virtual;
                     function  ComStateDTR:Boolean; virtual;
                     function  ComStateRTS:Boolean; virtual;
                     function  ComStateCTS:Boolean; virtual;
                     function  ComStateDSR:Boolean; virtual;
                     function  ComStateDCD:Boolean; virtual;
                     function  ComStateRI:Boolean; virtual;
                     function  ComStateDeltaCTS:Boolean; virtual;
                     function  ComStateDeltaDSR:Boolean; virtual;
                     function  ComStateDeltaDCD:Boolean; virtual;
                     function  ComStateDeltaRI:Boolean; virtual;
                end;


type TDataLink = object (TComInt)
                   constructor ComInit (ComPort:Byte);
                   constructor ComInithCom (ComPort:Byte; hCom:THANDLE);
                   function RS_Global_Yield(hWnd:Word):LongInt;  virtual;
                   procedure RS_SetYieldState(State:Boolean);   virtual;
                   function RS_GetYieldState:Boolean;  virtual;
                   procedure RS_TXOnLine (SCh:Char); virtual;
                   procedure RS_RXOnLine (var RCh:Char); virtual;
                   function  RS_TXInTime (SCh:Char; WaitTime:TSYSTIME):Boolean; virtual;
                   function  RS_RXInTime (var RCh:Char; WaitTime:TSYSTIME):Boolean; virtual;
                   function  RS_ErrorState:Byte;virtual;
                   function  RS_ModemState:Byte;virtual;
                   function  RS_LineState :Byte;virtual;
                   procedure RS_Break; virtual;
                   function  RS_XOFFLimit :Word;virtual;
                   function  RS_XONLimit  :Word;virtual;
                   procedure RS_DisableUserBreak;  virtual;
                   procedure RS_EnableUserBreak;   virtual;
                   function  RS_UserBreak:Boolean; virtual;
                   procedure RS_UserBreakOption(Option:Integer);  virtual;
                   procedure RS_UserBreakPressed;  virtual;
                   procedure RS_Delay (WaitTime:TSYSTIME); virtual;
                   procedure RS_SetXONLimit(XONLimit:Word); virtual;
                   procedure RS_SetXOFFLimit(XOFFLimit:Word); virtual;
                   function RS_GetXONState:Boolean; virtual;
                   procedure RS_SetXONState(State:Boolean); virtual;
                   procedure RS_TXCtlChar(CtlChar:Char; minWait, maxWait:TSYSTIME);  virtual;
              end;

type TTransport=object(TDataLink)
          constructor ComInit (ComPort:Byte);
          constructor ComInithCom (ComPort:Byte; hCom:THANDLE);
          procedure RS_TXPacket (var Packet; Len:Word; var Result:Word); virtual;
          procedure RS_RXPacket (var Packet; Len:Word; var Result:Word); virtual;
          procedure RS_TXQPacket (var Packet; Len:Word; var Result:Word); virtual;
          procedure RS_RXQPacket (var Packet; Len:Word; var Result:Word); virtual;
          procedure RS_TXPInTime(var Packet; Len:Word; OneChDelay:TSYSTIME; var Result:Word); virtual;
          procedure RS_RXPInTime(var Packet; Len:Word; OneChDelay:TSYSTIME; var Result:Word); virtual;
          function  RS_GetChkSum (var Packet; Len:Word):Byte; virtual;
          procedure Do_CRC (var CRC:SHORT; Ch:Char); virtual;
          procedure RS_GetCRC_CCITT (var Packet; Len:Word; var CRC:SHORT);  virtual;
          procedure RS_GetCRC_CCITT32 (var Packet; Len:Word; var CRC:LongInt); virtual;
          procedure Do_CRC32(var CRC:LongInt; Ch:Char);  virtual;
          function  RS_GetTimeZone:LongInt; virtual;
          procedure RS_SetTimeZone(TimeZone:LongInt); virtual;
          procedure RS_FileDateToDos (DateInSec:LongInt; var Year:Word; var Month:Word;
                                      var Day:Word; var Hour:Word; var Min:Word; var Sec:Word); virtual;
          function RS_FileDateToUnix(Year, Month, Day, Hour, Min, Sec:Word):LongInt; virtual;
        end;

type TModem = object(TTransport)
                   constructor ComInit (ComPort:Byte);
                   constructor ComInithCom (ComPort:Byte; hCom:THANDLE);
                   function  RS_Carrier:Boolean;   virtual;
                   procedure RS_Dial(Number:PCHAR); virtual;
                   procedure RS_HangUp; virtual;
                   procedure RS_PickUp; virtual;
                   function  RS_Ringing:Boolean;  virtual;
                   procedure RSH_HangUp; virtual;
                   procedure RSH_PickUp; virtual;
                   procedure RSH_ModemInit(InitString:PCHAR); virtual;
				           procedure RSH_ModemWaitOK; virtual;
                   function  RS_Connect(ConnectDelay:TSYSTIME;
                                        CheckModemResult:Boolean;
                                        ModemResult:PCHAR;
                                        InfoProc:TInfoProc):Boolean; virtual;
              end;


{ DLL exports }
function _ComGetVersion:Word;  stdcall;
procedure _ComInit (Com:Byte); stdcall;
procedure _ComInithCom (Com:Byte; hCom:THANDLE);    stdcall;
function _ComGethCom(Com:Byte):THANDLE;   stdcall;
function _ComGetSetEventProc(Com:Byte; EventProc:PUSEREVENTPROC):PUSEREVENTPROC;  stdcall;
procedure _ComSetBufSize (Com:Byte; RxBufferSize:TDWORD; TxBufferSize:TDWORD);   stdcall;
function  _ComResult(Com:Byte):Word;   stdcall;
procedure _ComSaveState(Com:Byte);    stdcall;
procedure _ComRestoreState(Com:Byte; var SaveState:TSAVESTATE);  stdcall;
procedure _ComSaveStateEx(Com:Byte; var SaveState:TSAVESTATE);   stdcall;
procedure _ComXCHGState(Com:Byte; var CurState:TSAVESTATE; var NewState:TSAVESTATE);  stdcall;
procedure _ComSetState (Com:Byte;
		                    NewBaud:LongInt;
                        NewDataBits:Byte;
		                    NewStopBits:Byte;
                        NewParity:Char;
                        NewFlow:Byte);  stdcall;
procedure _ComSetStateEx (Com:Byte;
                          NewBaud:LongInt;
                          NewDataBits:Byte;
                          NewStopBits:Byte;
                          NewParity:Char;
                          NewFlow:Byte;
                          SignalState:Byte);  stdcall;
procedure _ComSetBaudRate(Com:Byte; NewBaud:LongInt);  stdcall;
function _ComGetBaudRate(Com:Byte):LongInt;   stdcall;
function _ComGetMaxBaudRate(Com:Byte):LongInt;    stdcall;
procedure _ComReset (Com:Byte);   stdcall;
procedure _ComResetEx (Com:Byte; SignalState:Byte);   stdcall;
procedure _ComSetXONXOFFChars (Com:Byte; NewXONChar, NewXOFFChar:Char); stdcall;
function _ComGetXONXOFFChars(Com:Byte):Word;  stdcall;
procedure _ComSetXONState(Com:Byte; State:Boolean);  stdcall;
function  _ComGetEvent  (Com:Byte):Byte;    stdcall;
function  _ComGetEventEx (Com:Byte):Word;   stdcall;
function _ComPeekByte (Com:Byte; Bofs:Byte):Byte;    stdcall;
function _ComPeekWord (Com:Byte; Bofs:Byte):Word;    stdcall;
function _ComPeekLong (Com:Byte; Bofs:Byte):TDWORD;  stdcall;
procedure _ComPokeByte (Com:Byte; Bofs:Byte; Data:Byte);  stdcall;
procedure _ComPokeWord (Com:Byte; Bofs:Byte; Data:Word);   stdcall;
procedure _ComPokeLong (Com:Byte; Bofs:Byte; Data:TDWORD);  stdcall;
function _ComRead     (Com:Byte; var RCh:Char):Boolean;  stdcall;
function _ComWrite    (Com:Byte; SCh:Char):Boolean;   stdcall;
function _ComKickOut  (Com:Byte; SCh:Char):Boolean;   stdcall;
function _ComKickOutXOFF (Com:Byte):Boolean;   stdcall;
function _ComKickOutXON (Com:Byte):Boolean;    stdcall;
function  _ComBufSize (Com:Byte; BufDir:TBufDir):TDWORD;    stdcall;
function  _ComBufCount (Com:Byte; BufDir:TBufDir):TDWORD;   stdcall;
function  _ComGetSysTime:TSYSTIME;   stdcall;
function  _ComGetElapsedTime (Start:TSYSTIME):TSYSTIME;  stdcall;
function  _ComBufFull  (Com:Byte; BufDir:TBufDir):Boolean;  stdcall;
function  _ComBufEmpty (Com:Byte; BufDir:TBufDir):Boolean;  stdcall;
procedure _ComBufClear (Com:Byte; BufDir:TBufDir);  stdcall;
procedure _ComSetFlow  (Com:Byte;Flow:Byte);  stdcall;
function  _ComGetFlow  (Com:Byte):Byte;   stdcall;
procedure _ComEnableTX (Com:Byte);  stdcall;
function  _ComSpyChar (Com:Byte; var RCh:Char):Boolean;  stdcall;
function  _ComUngetChar (Com:Byte; SCh:Char):Boolean;    stdcall;
function _ComSpyCharEx (Com:Byte; var RCh:Char; BufDir:TBufDir; SpyPos:Word):Boolean; stdcall;
function _ComSwapChar (Com:Byte; BufDir:TBufDir; SpyPos:Word; NewCh:Char):Char;  stdcall;
function  _ComModemState (Com:Byte):Byte;   stdcall;
function  _ComLineState  (Com:Byte):Byte;   stdcall;
function  _ComXONState   (Com:Byte):Boolean; stdcall;
procedure _ComDTROn  (Com:Byte);   stdcall;
procedure _ComRTSOn  (Com:Byte);   stdcall;
procedure _ComDTROff (Com:Byte);   stdcall;
procedure _ComRTSOff (Com:Byte);   stdcall;
procedure _ComBreakOn (Com:Byte);  stdcall;
procedure _ComBreakOff(Com:Byte);  stdcall;
function  _ComGetMCReg (Com:Byte):Byte;      stdcall;
procedure _ComPutMCReg (Com:Byte; Val:Byte); stdcall;
procedure _ComSetSCResult(Com:Byte; Res:Word);  stdcall;
function _ComFIFOEnabled (Com:Byte):Boolean;           stdcall;
function _ComDisableFIFO (Com:Byte):Boolean;           stdcall;
function _ComEnableFIFO (Com,Threshold:Byte):Boolean;  stdcall;
function _ComGetIRQVec(IRQ:Byte):Byte;     stdcall;
function _ComValid(Com:Byte):Boolean;      stdcall;
function _ComRS485 (Com:Byte; Action:Byte):Boolean; stdcall;
function __GetUserCount(Com:Byte):Word; stdcall;
procedure _ComSetCOMName (szNewCOMName:PCHAR); stdcall;
procedure _ComSetRIQuard(Com:Byte; State:Boolean); stdcall;
procedure _ComSetRIGuard(Com:Byte; State:Boolean); stdcall;
function _ComGetSetEventMask (Com:Byte;
                              dwNewEventMask:TDWORD;
                              cEventChar:Char):TDWORD; stdcall;
function _ComHWBufSize (Com:Byte; BufDir:TBufDir):TDWORD; stdcall;
function _ComHWBufCount (Com:Byte; BufDir:TBufDir):TDWORD; stdcall;
function _ComGetProcess(Com:Byte):THANDLE; stdcall;
function _ComPortPresent(Com:Byte):Word; stdcall;
procedure _ComEnterCritSec; stdcall;
procedure _ComLeaveCritSec; stdcall;
procedure _ComEnterCritPortSec(Com:Byte); stdcall;
procedure _ComLeaveCritPortSec(Com:Byte); stdcall;
procedure _ComOpen (Com:Byte; InBuf:POINTER; InLen:Word;
		                OutBuf:POINTER; OutLen:Word); stdcall;
function _ComStateDTR(Com:Byte):Boolean;  stdcall;
function _ComStateRTS(Com:Byte):Boolean;  stdcall;
function _ComStateCTS(Com:Byte):Boolean;  stdcall;
function _ComStateDSR(Com:Byte):Boolean;  stdcall;
function _ComStateDCD(Com:Byte):Boolean;  stdcall;
function _ComStateRI(Com:Byte):Boolean;   stdcall;
function _ComStateDeltaCTS(Com:Byte):Boolean;  stdcall;
function _ComStateDeltaDSR(Com:Byte):Boolean;  stdcall;
function _ComStateDeltaDCD(Com:Byte):Boolean;  stdcall;
function _ComStateDeltaRI(Com:Byte):Boolean;   stdcall;


{****************************************************}
{*                DataLink                          *}
{*                                                  *}
{****************************************************}

function _RS_Global_Yield(Wnd:HWND):TDWORD;   stdcall;
function _RS_GetYieldState:Boolean;             stdcall;
procedure _RS_SetYieldState(State:Boolean);     stdcall;
procedure _RS_TXOnLine (Com:Byte; SCh:Char);      stdcall;
procedure _RS_RXOnLine (Com:Byte; var RCh:Char);  stdcall;
function  _RS_TXInTime (Com:Byte; SCh:Char; WaitTime:TSYSTIME):Boolean;      stdcall;
function  _RS_RXInTime (Com:Byte; var RCh:Char; WaitTime:TSYSTIME):Boolean;  stdcall;
function  _RS_ErrorState (Com:Byte):Byte;   stdcall;
function  _RS_ModemState(Com:Byte):Byte;    stdcall;
function  _RS_LineState (Com:Byte):Byte;    stdcall;
procedure _RS_Break (Com:Byte);  stdcall;
function  _RS_XOFFLimit (Com:Byte):Word;   stdcall;
function  _RS_XONLimit  (Com:Byte):Word;   stdcall;
function  _RS_UserBreak:Boolean; stdcall;
procedure _RS_DisableUserBreak; stdcall;
procedure _RS_EnableUserBreak;  stdcall;
procedure _RS_UserBreakOption(Option:Integer);  stdcall;
procedure _RS_UserBreakPressed;  stdcall;
procedure _RS_Delay (WaitTime:TSYSTIME);  stdcall;
procedure _RS_SetXONLimit (Com:Byte; XONLimit:Word);  stdcall;
procedure _RS_SetXOFFLimit (Com:Byte; XOFFLimit:Word); stdcall;
function _RS_GetXONState(Com:Byte):Boolean;  stdcall;
procedure _RS_SetXONState(Com:Byte; State:Boolean);  stdcall;
procedure _RS_TXCtlChar(Com:Byte; CtlChar:Char; minWait, maxWait:TSYSTIME);  stdcall;

{****************************************************}
{*                TransPort                         *}
{*                                                  *}
{****************************************************}

procedure _RS_TXPacket (Com:Byte; var Packet; Len:Word; var Result:Word);  stdcall;
procedure _RS_RXPacket (Com:Byte; var Packet; Len:Word; var Result:Word);  stdcall;
procedure _RS_TXQPacket (Com:Byte; var Packet; Len:Word; var Result:Word);  stdcall;
procedure _RS_RXQPacket (Com:Byte; var Packet; Len:Word; var Result:Word);  stdcall;
procedure _RS_TXPInTime(Com:Byte; var Packet; Len:Word; OneChDelay:TSYSTIME; var Result:Word);  stdcall;
procedure _RS_RXPInTime(Com:Byte; var Packet; Len:Word; OneChDelay:TSYSTIME; var Result:Word);  stdcall;
function _RS_GetChkSum (var Packet; Len:Word):Byte;   stdcall;
procedure _Do_CRC (var CRC:SHORT; Ch:Char);   stdcall;
procedure _RS_GetCRC_CCITT (var Packet; Len:Word; var CRC:SHORT);  stdcall;
procedure _RS_GetCRC_CCITT32 (var Packet; Len:Word; var CRC:LongInt); stdcall;
procedure _Do_CRC32(var CRC:LongInt; Ch:Char);   stdcall;
function _RS_GetTimeZone:LongInt;  stdcall;
procedure _RS_SetTimeZone(TimeZone:LongInt);  stdcall;
procedure _RS_FileDateToDos (DateInSec:LongInt; var Year:Word; var Month:Word;
                             var Day:Word; var Hour:Word; var Min:Word; var Sec:Word);  stdcall;
function _RS_FileDateToUnix(Year, Month, Day, Hour, Min, Sec:Word):LongInt;   stdcall;


{****************************************************}
{*                  Modem                           *}
{*                                                  *}
{****************************************************}

function  _RS_Carrier (Com:Byte):Boolean; stdcall;
procedure _RS_Dial    (Com:Byte; Number:PCHAR);  stdcall;
procedure _RS_HangUp  (Com:Byte);  stdcall;
procedure _RS_PickUp  (Com:Byte);  stdcall;
function  _RS_Ringing (Com:Byte):Boolean;  stdcall;
procedure _RSH_HangUp (Com:Byte);  stdcall;
procedure _RSH_PickUp (Com:Byte);  stdcall;
procedure _RSH_ModemInit(Com:Byte; InitString:PCHAR);  stdcall;
procedure _RSH_ModemWaitOK(Com:Byte); stdcall;
function  _RS_Connect(Com:Byte;
                      ConnectDelay:TSYSTIME;
                      CheckModemResult:Boolean;
                      ModemResult:PCHAR;
                      InfoProc:TInfoProc):Boolean;    stdcall;

implementation

procedure _ComInit;              stdcall;  external DLL_Path name 'ComInit';
function  _ComGetBaudRate;       stdcall;  external DLL_Path name 'ComGetBaudRate';
function  _ComGetMaxBaudRate;    stdcall;  external DLL_Path name 'ComGetMaxBaudRate';
procedure _ComSetState;          stdcall;  external DLL_Path name 'ComSetState';
procedure _ComSetStateEx;        stdcall;  external DLL_Path name 'ComSetStateEx';
procedure _ComReset;             stdcall;  external DLL_Path name 'ComReset';
procedure _ComResetEx;           stdcall;  external DLL_Path name 'ComResetEx';
function  _ComResult;            stdcall;  external DLL_Path name 'ComResult';
function  _ComGetEvent;          stdcall;  external DLL_Path name 'ComGetEvent';
function  _ComGetEventEx;        stdcall;  external DLL_Path name 'ComGetEventEx';
procedure _ComSetXONXOFFChars;   stdcall;  external DLL_Path name 'ComSetXONXOFFChars';
function  _ComGetXONXOFFChars;   stdcall;  external DLL_Path name 'ComGetXONXOFFChars';
function  _ComPeekByte;          stdcall;  external DLL_Path name 'ComPeekByte';
function  _ComPeekWord;          stdcall;  external DLL_Path name 'ComPeekWord';
function  _ComPeekLong;          stdcall;  external DLL_Path name 'ComPeekLong';
procedure _ComPokeByte;          stdcall;  external DLL_Path name 'ComPokeByte';
procedure _ComPokeWord;          stdcall;  external DLL_Path name 'ComPokeWord';
procedure _ComPokeLong;          stdcall;  external DLL_Path name 'ComPokeLong';
function  _ComRead;              stdcall;  external DLL_Path name 'ComRead';
function  _ComWrite;             stdcall;  external DLL_Path name 'ComWrite';
function  _ComKickOut;           stdcall;  external DLL_Path name 'ComKickOut';
function  _ComBufSize;           stdcall;  external DLL_Path name 'ComBufSize';
function  _ComBufCount;          stdcall;  external DLL_Path name 'ComBufCount';
procedure _ComBufClear;          stdcall;  external DLL_Path name 'ComBufClear';
function  _ComBufFull;           stdcall;  external DLL_Path name 'ComBufFull';
function  _ComBufEmpty;          stdcall;  external DLL_Path name 'ComBufEmpty';
procedure _ComSetFlow;           stdcall;  external DLL_Path name 'ComSetFlow';
function  _ComGetFlow;           stdcall;  external DLL_Path name 'ComGetFlow';
function  _ComModemState;        stdcall;  external DLL_Path name 'ComModemState';
function  _ComLineState;         stdcall;  external DLL_Path name 'ComLineState';
function  _ComXONState;          stdcall;  external DLL_Path name 'ComXONState';
procedure _ComSetXONState;       stdcall;  external DLL_Path name 'ComSetXONState';
procedure _ComDTROn;             stdcall;  external DLL_Path name 'ComDTROn';
procedure _ComRTSOn;             stdcall;  external DLL_Path name 'ComRTSOn';
procedure _ComDTROff;            stdcall;  external DLL_Path name 'ComDTROff';
procedure _ComRTSOff;            stdcall;  external DLL_Path name 'ComRTSOff';
procedure _ComBreakOn;           stdcall;  external DLL_Path name 'ComBreakOn';
procedure _ComBreakOff;          stdcall;  external DLL_Path name 'ComBreakOff';
function  _ComGetMCReg;          stdcall;  external DLL_Path name 'ComGetMCReg';
procedure _ComPutMCReg;          stdcall;  external DLL_Path name 'ComPutMCReg';
function  _ComFIFOEnabled;       stdcall;  external DLL_Path name 'ComFIFOEnabled';
function  _ComEnableFIFO;        stdcall;  external DLL_Path name 'ComEnableFIFO';
function  _ComDisableFIFO;       stdcall;  external DLL_Path name 'ComDisableFIFO';
procedure _ComSaveState;         stdcall;  external DLL_Path name 'ComSaveState';
procedure _ComRestoreState;      stdcall;  external DLL_Path name 'ComRestoreState';
procedure _ComXCHGState;         stdcall;  external DLL_Path name 'ComXCHGState';
function  _ComValid;             stdcall;  external DLL_Path name 'ComValid';
procedure _ComSetSCResult;       stdcall;  external DLL_Path name 'ComSetSCResult';
function  _ComGetSysTime;        stdcall;  external DLL_Path name 'ComGetSysTime';
function  _ComGetElapsedTime;    stdcall;  external DLL_Path name 'ComGetElapsedTime';
function  _ComGethCom;           stdcall;  external DLL_Path name 'ComGethCom';
function  _RS_GetXONState;       stdcall;  external DLL_Path name 'RS_GetXONState';
procedure _RS_SetXONState;       stdcall;  external DLL_Path name 'RS_SetXONState';
procedure _RS_TXOnLine;          stdcall;  external DLL_Path name 'RS_TXOnLine';
procedure _RS_RXOnLine;          stdcall;  external DLL_Path name 'RS_RXOnLine';
function  _RS_TXInTime;          stdcall;  external DLL_Path name 'RS_TXInTime';
function  _RS_RXInTime;          stdcall;  external DLL_Path name 'RS_RXInTime';
function  _RS_ErrorState;        stdcall;  external DLL_Path name 'RS_ErrorState';
function  _RS_ModemState;        stdcall;  external DLL_Path name 'RS_ModemState';
function  _RS_LineState;         stdcall;  external DLL_Path name 'RS_LineState';
procedure _RS_Break;             stdcall;  external DLL_Path name 'RS_Break';
procedure _RS_DisableUserBreak;  stdcall;  external DLL_Path name 'RS_DisableUserBreak';
procedure _RS_EnableUserBreak;   stdcall;  external DLL_Path name 'RS_EnableUserBreak';
function  _RS_UserBreak;         stdcall;  external DLL_Path name 'RS_UserBreak';
procedure _RS_UserBreakPressed;  stdcall;  external DLL_Path name 'RS_UserBreakPressed';
procedure _RS_Delay;             stdcall;  external DLL_Path name 'RS_Delay';
function  _RS_Global_Yield;      stdcall;  external DLL_Path name 'RS_Global_Yield';
function  _RS_GetYieldState;     stdcall;  external DLL_Path name 'RS_GetYieldState';
procedure _RS_SetYieldState;     stdcall;  external DLL_Path name 'RS_SetYieldState';
function  _RS_XOFFLimit;         stdcall;  external DLL_Path name 'RS_XOFFLimit';
function  _RS_XONLimit;          stdcall;  external DLL_Path name 'RS_XONLimit';
procedure _RS_TXPacket;          stdcall;  external DLL_Path name 'RS_TXPacket';
procedure _RS_RXPacket;          stdcall;  external DLL_Path name 'RS_RXPacket';
procedure _RS_TXPInTime;         stdcall;  external DLL_Path name 'RS_TXPInTime';
procedure _RS_RXPInTime;         stdcall;  external DLL_Path name 'RS_RXPInTime';
procedure _RS_UserBreakOption;   stdcall;  external DLL_Path name 'RS_UserBreakOption';
procedure _RS_SetXONLimit;       stdcall;  external DLL_Path name 'RS_SetXONLimit';
procedure _RS_SetXOFFLimit;      stdcall;  external DLL_Path name 'RS_SetXOFFLimit';
procedure _RS_TXQPacket;         stdcall;  external DLL_Path name 'RS_TXQPacket';
procedure _RS_RXQPacket;         stdcall;  external DLL_Path name 'RS_RXQPacket';
function  _RS_Carrier;           stdcall;  external DLL_Path name 'RS_Carrier';
procedure _RS_Dial;              stdcall;  external DLL_Path name 'RS_Dial';
procedure _RS_HangUp;            stdcall;  external DLL_Path name 'RS_HangUp';
procedure _RS_PickUp;            stdcall;  external DLL_Path name 'RS_PickUp';
function  _RS_Ringing;           stdcall;  external DLL_Path name 'RS_Ringing';
procedure _RSH_HangUp;           stdcall;  external DLL_Path name 'RSH_HangUp';
procedure _RSH_PickUp;           stdcall;  external DLL_Path name 'RSH_PickUp';
function  _RS_Connect;           stdcall;  external DLL_Path name 'RS_Connect';
procedure _RSH_ModemInit;        stdcall;  external DLL_Path name 'RSH_ModemInit';
procedure _RSH_ModemWaitOK;      stdcall;  external DLL_Path name 'RSH_ModemWaitOK';
procedure _ComSaveStateEx;       stdcall;  external DLL_Path name 'ComSaveStateEx';
procedure _ComSetBaudRate;       stdcall;  external DLL_Path name 'ComSetBaudRate';
procedure _ComEnableTX;          stdcall;  external DLL_Path name 'ComEnableTX';
function  _ComKickOutXOFF;       stdcall;  external DLL_Path name 'ComKickOutXOFF';
function  _ComKickOutXON;        stdcall;  external DLL_Path name 'ComKickOutXON';
procedure _RS_TXCtlChar;         stdcall;  external DLL_Path name 'RS_TXCtlChar';
function  _RS_GetChkSum;         stdcall;  external DLL_Path name 'RS_GetChkSum';
procedure _RS_GetCRC_CCITT;      stdcall;  external DLL_Path name 'RS_GetCRC_CCITT';
function  _ComRS485;             stdcall;  external DLL_Path name 'ComRS485';
function  _ComGetVersion;        stdcall;  external DLL_Path name 'ComGetVersion';
function  __GetUserCount;        stdcall;  external DLL_Path name 'GetUserCount';
function  _ComGetIRQVec;         stdcall;  external DLL_Path name 'ComGetIRQVec';
function  _RS_GetTimeZone;       stdcall;  external DLL_Path name 'RS_GetTimeZone';
procedure _RS_SetTimeZone;       stdcall;  external DLL_Path name 'RS_SetTimeZone';
procedure _Do_CRC;               stdcall;  external DLL_Path name 'Do_CRC';
function  _RS_FileDateToUnix;    stdcall;  external DLL_Path name 'RS_FileDateToUnix';
procedure _RS_FileDateToDos;     stdcall;  external DLL_Path name 'RS_FileDateToDos';
procedure _Do_CRC32;             stdcall;  external DLL_Path name 'Do_CRC32';
procedure _RS_GetCRC_CCITT32;    stdcall;  external DLL_Path name 'RS_GetCRC_CCITT32';
procedure _ComSetBufSize;        stdcall;  external DLL_Path name 'ComSetBufSize';
procedure _ComInithCom;          stdcall;  external DLL_Path name 'ComInithCom';
function _ComSpyChar;            stdcall;  external DLL_Path name 'ComSpyChar';
function _ComUngetChar;          stdcall;  external DLL_Path name 'ComUngetChar';
function _ComSpyCharEx;          stdcall;  external DLL_Path name 'ComSpyCharEx';
function _ComSwapChar;           stdcall;  external DLL_Path name 'ComSwapChar';
function _ComGetSetEventProc;    stdcall;  external DLL_Path name 'ComGetSetEventProc';
procedure _ComSetCOMName; stdcall;  external DLL_Path name 'ComSetCOMName';
procedure _ComSetRIQuard; stdcall;  external DLL_Path name 'ComSetRIQuard';
procedure _ComSetRIGuard; stdcall;  external DLL_Path name 'ComSetRIQuard';
function _ComGetSetEventMask; stdcall;  external DLL_Path name 'ComGetSetEventMask';
function _ComHWBufSize; stdcall;  external DLL_Path name 'ComHWBufSize';
function _ComHWBufCount; stdcall;  external DLL_Path name 'ComHWBufCount';
function _ComGetProcess; stdcall;  external DLL_Path name 'ComGetProcess';
function _ComPortPresent; stdcall; external DLL_Path name 'ComPortPresent';
procedure _ComEnterCritSec; stdcall; external DLL_Path name 'ComEnterCritSec';
procedure _ComLeaveCritSec; stdcall; external DLL_Path name 'ComLeaveCritSec';
procedure _ComEnterCritPortSec; stdcall; external DLL_Path name 'ComEnterCritPortSec';
procedure _ComLeaveCritPortSec; stdcall; external DLL_Path name 'ComLeaveCritPortSec';
procedure _ComOpen; stdcall; external DLL_Path name 'ComOpen';
function _ComStateDTR;  stdcall; external DLL_Path name 'ComStateDTR';
function _ComStateRTS;  stdcall; external DLL_Path name 'ComStateRTS';
function _ComStateCTS;  stdcall; external DLL_Path name 'ComStateCTS';
function _ComStateDSR;  stdcall; external DLL_Path name 'ComStateDSR';
function _ComStateDCD;  stdcall; external DLL_Path name 'ComStateDCD';
function _ComStateRI;   stdcall; external DLL_Path name 'ComStateRI';
function _ComStateDeltaCTS;  stdcall; external DLL_Path name 'ComStateDeltaCTS';
function _ComStateDeltaDSR;  stdcall; external DLL_Path name 'ComStateDeltaDSR';
function _ComStateDeltaDCD;  stdcall; external DLL_Path name 'ComStateDeltaDCD';
function _ComStateDeltaRI;   stdcall; external DLL_Path name 'ComStateDeltaRI';

function TComInt.GetCom:Byte;
begin
   GetCom:=_Com;
end;

function TComInt.ComGetVersion:Word;
begin
   ComGetVersion:=_ComGetVersion;
end;

constructor TComInt.ComInit (ComPort:Byte);
begin
   _Com:=ComPort;
   _ComInit(_Com);
end;

constructor TComInt.ComInithCom (ComPort:Byte; hCom:THANDLE);
begin
   _Com:=ComPort;
   _ComInithCom(_Com,hCom);
end;

function TComInt.ComGethCom:THANDLE;
begin
   ComGethCom:=_ComGethCom(_Com);
end;

function TComInt.ComGetSetEventProc(EventProc:PUSEREVENTPROC):PUSEREVENTPROC;
begin
   ComGetSetEventProc:=_ComGetSetEventProc(_Com,EventProc);
end;

procedure TComInt.ComSetBufSize (RxBufferSize:TDWORD; TxBufferSize:TDWORD);
begin
   _ComSetBufSize (_Com, RxBufferSize, TxBufferSize);
end;

function TComInt.ComGetSysTime:TSYSTIME;
begin
   ComGetSysTime:=_ComGetSysTime;
end;

function TComInt.ComGetElapsedTime(Start:TSYSTIME):TSYSTIME;
begin
   ComGetElapsedTime:=_ComGetElapsedTime(Start);
end;

function TComInt.ComBufSize(BufDir:TBufDir):TDWORD;
begin
   ComBufSize:=_ComBufSize(_Com,TBufDir(BufDir));
end;

function TComInt.ComBufCount (BufDir:TBufDir):TDWORD;
begin
   ComBufCount:=_ComBufCount(_Com,TBufDir(BufDir));
end;

function TComInt.ComValid(Com:Byte):Boolean;
begin
   ComValid:=_ComValid(Com);
end;

function TComInt.ComGetEventEx:Word;
begin
   ComGetEventEx:=_ComGetEventEx(_Com);
end;

function TComInt.ComGetEvent:Byte;
begin
   ComGetEvent:=_ComGetEvent(_Com);
end;

procedure TComInt.ComSetXONXOFFChars (NewXONChar, NewXOFFChar:Char);
begin
   _ComSetXONXOFFChars (_Com,NewXONChar, NewXOFFChar);
end;

function TComInt.ComGetXONXOFFChars:Word;
begin
   ComGetXONXOFFChars:=_ComGetXONXOFFChars (_Com);
end;

procedure TComInt.ComSetXONState(State:Boolean);
begin
   _ComSetXONState(_Com,State);
end;

procedure TComInt.ComSetSCResult(Res:WORD);
begin
   _ComSetSCResult(_Com,Res);
end;

function TComInt.ComResult:WORD;
begin
   ComResult:=_ComResult(_Com);
end;

procedure TComInt.ComSaveState;
begin
   _ComSaveState(_Com);
end;

procedure TComInt.ComRestoreState(var SaveState:TSAVESTATE);
begin
   _ComRestoreState(_Com,TSaveState(SaveState));
end;

procedure TComInt.ComXCHGState(var CurState:TSAVESTATE; var NewState:TSAVESTATE);
begin
   _ComXCHGState(_Com,TSaveState(CurState),TSaveState(NewState));
end;

procedure TComInt.ComSaveStateEx(var SaveState:TSAVESTATE);
begin
   _ComSaveStateEx(_Com,TSaveState(SaveState));
end;

procedure TComInt.ComEnableTX;
begin
   _ComEnableTX(_Com);
end;

function TComInt.ComSpyChar(var RCh:Char):Boolean;
begin
   ComSpyChar:=_ComSpyChar(_Com,RCh);
end;

function TComInt.ComUngetChar (SCh:Char):Boolean;
begin
   ComUngetChar:=_ComUngetChar(_Com, SCh);
end;

function TComInt.ComSpyCharEx (var RCh:Char; BufDir:TBufDir; SpyPos:Word):Boolean;
begin
   ComSpyCharEx:=_ComSpyCharEx(_Com, RCh, BufDir, SpyPos);
end;

function TComInt.ComSwapChar (BufDir:TBufDir; SpyPos:Word; NewCh:Char):Char;
begin
   ComSwapChar:=_ComSwapChar(_Com, BufDir, SpyPos, NewCh);
end;

function TComInt.COMSWBUFCOUNT(BufDir:TBufDir):Word;
begin
  COMSWBUFCOUNT:=(_ComBufCount(_Com,BufDir) - _ComHWBufCount(_Com,BufDir));
end;

procedure TComInt.ComSetFlow(Flow:Byte);
begin
   _ComSetFlow(_Com,Flow);
end;

function TComInt.ComGetFlow:Byte;
begin
   ComGetFlow:=_ComGetFlow(_Com);
end;

procedure TComInt.ComSetState (NewBaud:LongInt;
                               NewDataBits:Byte;
                               NewStopBits:Byte;
                               NewParity:Char;
                               NewFlow:Byte);
begin
   _ComSetState(_Com,NewBaud,NewDataBits,NewStopBits,NewParity,NewFlow);
end;

procedure TComInt.ComSetStateEx (NewBaud:LongInt;
                               NewDataBits:Byte;
                               NewStopBits:Byte;
                               NewParity:Char;
                               NewFlow:Byte;
                               SignalState:Byte);
begin
   _ComSetStateEx(_Com,NewBaud,NewDataBits,NewStopBits,NewParity,NewFlow,SignalState);
end;

procedure TComInt.ComSetBaudRate(NewBaud:LongInt);
begin
   _ComSetBaudRate(_Com,NewBaud);
end;

function TComInt.ComGetBaudRate:LongInt;
begin
   ComGetBaudRate:=_ComGetBaudRate(_Com);
end;

function TComInt.ComGetMaxBaudRate:LongInt;
begin
   ComGetMaxBaudRate:=_ComGetMaxBaudRate(_Com);
end;

procedure TComInt.ComReset;
begin
   _ComReset(_Com);
end;

procedure TComInt.ComResetEx(SignalState:Byte);
begin
   _ComResetEx(_Com, SignalState);
end;

function TComInt.ComPeekByte (Bofs:Byte):Byte;
begin
   ComPeekByte:=_ComPeekByte(_Com,Bofs);
end;

function TComInt.ComPeekWord (Bofs:Byte):Word;
begin
   ComPeekWord:=_ComPeekWord(_Com,Bofs);
end;

function TComInt.ComPeekLong (Bofs:Byte):TDWORD;
begin
   ComPeekLong:=_ComPeekLong(_Com,Bofs);
end;

procedure TComInt.ComPokeByte (Bofs:Byte; Data:Byte);
begin
   _ComPokeByte(_Com,Bofs,Data);
end;

procedure TComInt.ComPokeWord (Bofs:Byte; Data:Word);
begin
   _ComPokeWord(_Com,Bofs,Data);
end;

procedure TComInt.ComPokeLong (Bofs:Byte; Data:TDWORD);
begin
   _ComPokeLong(_Com,Bofs,Data);
end;

function  TComInt.ComRead (var RCh:Char):Boolean;
begin
   ComRead:=_ComRead(_Com,RCh);
end;

function  TComInt.ComWrite (SCh:Char):Boolean;
begin
   ComWrite:=_ComWrite(_Com,SCh);
end;

function TComInt.ComKickOut (SCh:Char):Boolean;
begin
   ComKickOut:=_ComKickOut(_Com,SCh);
end;

function TComInt.ComKickOutXOFF:Boolean;
begin
   ComKickOutXOFF:=_ComKickOutXOFF(_Com);
end;

function TComInt.ComKickOutXON:Boolean;
begin
   ComKickOutXON:=_ComKickOutXON(_Com);
end;

procedure TComInt.ComBufClear (BufDir:TBufDir);
begin
   _ComBufClear(_Com,TBufDir(BufDir));
end;

function TComInt.ComBufFull (BufDir:TBufDir):Boolean;
begin
   ComBufFull:=_ComBufFull(_Com,TBufDir(BufDir));
end;

function TComInt.ComBufEmpty (BufDir:TBufDir):Boolean;
begin
   ComBufEmpty:=_ComBufEmpty(_Com,TBufDir(BufDir));
end;

function TComInt.ComModemState:Byte;
begin
   ComModemState:=_ComModemState(_Com);
end;

function TComInt.ComLineState:Byte;
begin
   ComLineState:=_ComLineState(_Com);
end;

function TComInt.ComXONState:Boolean;
begin
   ComXONState:=_ComXONState(_Com);
end;

procedure TComInt.ComDTROn;
begin
   _ComDTROn(_Com);
end;

procedure TComInt.ComRTSOn;
begin
   _ComRTSOn(_Com);
end;

procedure TComInt.ComDTROff;
begin
   _ComDTROff(_Com);
end;

procedure TComInt.ComRTSOff;
begin
   _ComRTSOff(_Com);
end;

procedure TComInt.ComBreakOn;
begin
   _ComBreakOn(_Com);
end;

procedure TComInt.ComBreakOff;
begin
   _ComBreakOff(_Com);
end;

function TComInt.ComGetMCReg:Byte;
begin
   ComGetMCReg:=_ComGetMCReg(_Com);
end;

procedure TComInt.ComPutMCReg (Val:Byte);
begin
   _ComPutMCReg(_Com,Val);
end;

function TComInt.ComFIFOEnabled:Boolean;
begin
   ComFIFOEnabled:=_ComFIFOEnabled(_Com);
end;

function TComInt.ComDisableFIFO:Boolean;
begin
   ComDisableFIFO:=_ComDisableFIFO(_Com);
end;

function TComInt.ComEnableFIFO(Threshold:Byte):Boolean;
begin
   ComEnableFIFO:=_ComEnableFIFO(_Com,Threshold);
end;

function TComInt.ComRS485 (Action:Byte):Boolean;
begin
   ComRS485:=_ComRS485(_Com,Action);
end;

function TComInt.ComGetIRQVec(IRQ:Byte):Byte;  { IRQ = 0..15 }
begin
   ComGetIRQVec:=_ComGetIRQVec(IRQ);
end;

function TComInt.ComGetSetEventMask (dwNewEventMask:TDWORD;
                                    cEventChar:Char):TDWORD;
begin
   ComGetSetEventMask:=_ComGetSetEventMask(_Com,dwNewEventMask,cEventChar);
end;

procedure TComInt.ComSetCOMName (szNewCOMName:PCHAR);
begin
   _ComSetCOMName(szNewCOMName);
end;

procedure TComInt.ComSetRIQuard(State:Boolean);
begin
   _ComSetRIQuard(_Com, State);
end;

procedure TComInt.ComSetRIGuard(State:Boolean);
begin
   _ComSetRIGuard(_Com, State);
end;

function TComInt.ComHWBufSize (BufDir:TBufDir):TDWORD;
begin
   ComHWBufSize:=_ComHWBufSize(_Com, BufDir);
end;

function TComInt.ComHWBufCount(BufDir:TBufDir):TDWORD;
begin
   ComHWBufCount:=_ComHWBufCount(_Com, BufDir);
end;

function TComInt.ComGetProcess:THANDLE;
begin
   ComGetProcess:=_ComGetProcess(_Com);
end;

function TComInt.ComPortPresent(Com:Byte):Word;
begin
   ComPortPresent:=_ComPortPresent(Com);
end;

procedure TComInt.ComEnterCritSec;
begin
   _ComEnterCritSec;
end;

procedure TComInt.ComLeaveCritSec;
begin
   _ComLeaveCritSec;
end;

procedure TComInt.ComEnterCritPortSec;
begin
   _ComEnterCritPortSec(_Com);
end;

procedure TComInt.ComLeaveCritPortSec;
begin
   _ComEnterCritPortSec(_Com);
end;

procedure TComInt.ComOpen (InBuf:POINTER; InLen:Word;
OutBuf:POINTER; OutLen:Word);
begin
   _ComOpen (_Com, InBuf, InLen, OutBuf, OutLen);
end;

function  TComInt.ComStateDTR:Boolean;
begin
   ComStateDTR:=_ComStateDTR(_Com);
end;

function  TComInt.ComStateRTS:Boolean;
begin
   ComStateRTS:=_ComStateRTS(_Com);
end;

function  TComInt.ComStateCTS:Boolean;
begin
   ComStateCTS:=_ComStateCTS(_Com);
end;

function  TComInt.ComStateDSR:Boolean;
begin
   ComStateDSR:=_ComStateDSR(_Com);
end;

function  TComInt.ComStateDCD:Boolean;
begin
   ComStateDCD:=_ComStateDCD(_Com);
end;

function  TComInt.ComStateRI:Boolean;
begin
   ComStateRI:=_ComStateRI(_Com);
end;

function  TComInt.ComStateDeltaCTS:Boolean;
begin
   ComStateDeltaCTS:=_ComStateDeltaCTS(_Com);
end;

function  TComInt.ComStateDeltaDSR:Boolean;
begin
   ComStateDeltaDSR:=_ComStateDeltaDSR(_Com);
end;

function  TComInt.ComStateDeltaDCD:Boolean;
begin
   ComStateDeltaDCD:=_ComStateDeltaDCD(_Com);
end;

function  TComInt.ComStateDeltaRI:Boolean;
begin
   ComStateDeltaRI:=_ComStateDeltaRI(_Com);
end;

{-----------------------------------------------------------}

constructor TDataLink.ComInit (ComPort:Byte);
begin
   TComInt.ComInit(ComPort);
end;

constructor TDataLink.ComInithCom (ComPort:Byte; hCom:THANDLE);
begin
   TComInt.ComInithCom(ComPort,hCom);
end;

function TDataLink.RS_Global_Yield(hWnd:Word):LongInt;
begin
   RS_Global_Yield:=_RS_Global_Yield(hWnd);
end;

procedure TDataLink.RS_SetYieldState(State:Boolean);
begin
   _RS_SetYieldState(State);
end;

function TDataLink.RS_GetYieldState:Boolean;
begin
   RS_GetYieldState:=_RS_GetYieldState;
end;

procedure TDataLink.RS_TXOnLine (SCh:Char);
begin
   _RS_TXOnLine(_Com,SCh);
end;

procedure TDataLink.RS_RXOnLine (var RCh:Char);
begin
   _RS_RXOnLine(_Com,RCh);
end;

function TDataLink.RS_TXInTime (SCh:Char; WaitTime:TSYSTIME):Boolean;
begin
   RS_TXInTime:=_RS_TXInTime(_Com,SCh,WaitTime);
end;

function TDataLink.RS_RXInTime (var RCh:Char; WaitTime:TSYSTIME):Boolean;
begin
   RS_RXInTime:=_RS_RXInTime(_Com,RCh,WaitTime);
end;

function TDataLink.RS_ErrorState:Byte;
begin
   RS_ErrorState:=_RS_ErrorState(_Com);
end;

function TDataLink.RS_ModemState:Byte;
begin
   RS_ModemState:=_RS_ModemState(_Com);
end;

function TDataLink.RS_LineState:Byte;
begin
   RS_LineState:=_RS_LineState(_Com);
end;

procedure TDataLink.RS_Break;
begin
   _RS_Break(_Com);
end;

function TDataLink.RS_XOFFLimit:Word;
begin
   RS_XOFFLimit:=_RS_XOFFLimit(_Com);
end;

function TDataLink.RS_XONLimit:Word;
begin
   RS_XONLimit:=_RS_XONLimit(_Com);
end;

procedure TDataLink.RS_DisableUserBreak;
begin
   _RS_DisableUserBreak;
end;

procedure TDataLink.RS_EnableUserBreak;
begin
   _RS_EnableUserBreak;
end;

function TDataLink.RS_UserBreak:Boolean;
begin
   RS_UserBreak:=_RS_UserBreak;
end;

procedure TDataLink.RS_UserBreakOption(Option:Integer);
begin
   _RS_UserBreakOption(Option);
end;

procedure TDataLink.RS_UserBreakPressed;
begin
   _RS_UserBreakPressed;
end;

procedure TDataLink.RS_Delay (WaitTime:TSYSTIME);
begin
   _RS_Delay(WaitTime);
end;

procedure TDataLink.RS_SetXONLimit(XONLimit:Word);
begin
   _RS_SetXONLimit(_Com,XONLimit);
end;

procedure TDataLink.RS_SetXOFFLimit(XOFFLimit:Word);
begin
   _RS_SetXOFFLimit(_Com,XOFFLimit);
end;

function TDataLink.RS_GetXONState:Boolean;
begin
   RS_GetXONState:=_RS_GetXONState(_Com);
end;

procedure TDataLink.RS_SetXONState(State:Boolean);
begin
   _RS_SetXONState(_Com,State);
end;

procedure TDataLink.RS_TXCtlChar(CtlChar:Char; minWait, maxWait:TSYSTIME);
begin
   _RS_TXCtlChar(_Com, CtlChar, minWait, maxWait);
end;

{-----------------------------------------------------------}

constructor TTransport.ComInit (ComPort:Byte);
begin
   TComInt.ComInit(ComPort);
end;

constructor TTransport.ComInithCom (ComPort:Byte; hCom:THANDLE);
begin
   TComInt.ComInithCom(ComPort,hCom);
end;

procedure TTransport.RS_TXPacket (var Packet; Len:Word; var Result:Word);
begin
   _RS_TXPacket(_Com,Packet,Len,Result);
end;

procedure TTransport.RS_RXPacket (var Packet; Len:Word; var Result:Word);
begin
   _RS_RXPacket(_Com,Packet,Len,Result);
end;

procedure TTransport.RS_TXQPacket (var Packet; Len:Word; var Result:Word);
begin
   _RS_TXQPacket(_Com,Packet,Len,Result);
end;

procedure TTransport.RS_RXQPacket (var Packet; Len:Word; var Result:Word);
begin
   _RS_RXQPacket(_Com,Packet,Len,Result);
end;

procedure TTransport.RS_TXPInTime(var Packet; Len:Word; OneChDelay:TSYSTIME; var Result:Word);
begin
   _RS_TXPInTime(_Com,Packet,Len,OneChDelay,Result);
end;

procedure TTransport.RS_RXPInTime(var Packet; Len:Word; OneChDelay:TSYSTIME; var Result:Word);
begin
   _RS_RXPInTime(_Com,Packet,Len,OneChDelay,Result);
end;

function TTransport.RS_GetChkSum (var Packet; Len:Word):Byte;
begin
   RS_GetChkSum:=_RS_GetChkSum(Packet,Len);
end;

procedure TTransport.Do_CRC (var CRC:SHORT; Ch:Char);
begin
   _Do_CRC(CRC,Ch);
end;

procedure TTransport.RS_GetCRC_CCITT (var Packet; Len:Word; var CRC:SHORT);
begin
   _RS_GetCRC_CCITT(Packet,Len,CRC);
end;

procedure TTransport.RS_GetCRC_CCITT32 (var Packet; Len:Word; var CRC:LongInt);
begin
   _RS_GetCRC_CCITT32(Packet,Len,CRC);
end;

procedure TTransport.Do_CRC32(var CRC:LongInt; Ch:Char);
begin
   _Do_CRC32(CRC,Ch);
end;

function TTransport.RS_GetTimeZone:LongInt;
begin
   RS_GetTimeZone:=_RS_GetTimeZone;
end;

procedure TTransport.RS_SetTimeZone(TimeZone:LongInt);
begin
   _RS_SetTimeZone(TimeZone);
end;

procedure TTransport.RS_FileDateToDos (DateInSec:LongInt; var Year:Word; var Month:Word;
                            var Day:Word; var Hour:Word; var Min:Word; var Sec:Word);
begin
   _RS_FileDateToDos (DateInSec,Year,Month,Day,Hour,Min,Sec);
end;

function TTransport.RS_FileDateToUnix(Year, Month, Day, Hour, Min, Sec:Word):LongInt;
begin
   RS_FileDateToUnix:=_RS_FileDateToUnix (Year,Month,Day,Hour,Min,Sec);
end;

{-----------------------------------------------------------}

constructor TModem.ComInit (ComPort:Byte);
begin
   TComInt.ComInit(ComPort);
end;

constructor TModem.ComInithCom (ComPort:Byte; hCom:THANDLE);
begin
   TComInt.ComInithCom(ComPort,hCom);
end;

function TModem.RS_Carrier:Boolean;
begin
   RS_Carrier:=_RS_Carrier(_Com);
end;

function TModem.RS_Ringing:Boolean;
begin
   RS_Ringing:=_RS_Ringing(_Com);
end;

procedure TModem.RS_HangUp;
begin
   _RS_HangUp(_Com);
end;

procedure TModem.RS_PickUp;
begin
   _RS_PickUp(_Com);
end;

procedure TModem.RS_Dial(Number:PCHAR);
begin
   _RS_Dial(_Com,Number);
end;

procedure TModem.RSH_HangUp;
begin
   _RSH_HangUp(_Com);
end;

procedure TModem.RSH_PickUp;
begin
   _RSH_PickUp(_Com);
end;

procedure TModem.RSH_ModemInit(InitString:PCHAR);
begin
  _RSH_ModemInit(_Com,InitString);
end;

procedure TModem.RSH_ModemWaitOK;
begin
  _RSH_ModemWaitOK(_Com);
end;

function TModem.RS_Connect(ConnectDelay:TSYSTIME;
                           CheckModemResult:Boolean;
                           ModemResult:PCHAR;
                           InfoProc:TInfoProc):Boolean;
begin
   RS_Connect:=_RS_Connect(_Com,
                           ConnectDelay,
                           CheckModemResult,
                           ModemResult,
                           TInfoProc(InfoProc));
end;

{No Init}

end.
