/****************************************************************************
**
** Copyright (C) 2005-2007 Trolltech ASA. All rights reserved.
**
** This file is part of the example classes of the Qt Toolkit.
**
** Licensees holding a valid Qt License Agreement may use this file in
** accordance with the rights, responsibilities and obligations
** contained therein.  Please consult your licensing agreement or
** contact sales@trolltech.com if any conditions of this licensing
** agreement are not clear to you.
**
** Further information about Qt licensing is available at:
** http://www.trolltech.com/products/qt/licensing.html or by
** contacting info@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include <QtGui>
#include "qtdemo.h"
#include "renderarea.h"
#include "timestamp.h"

RenderArea::RenderArea(QWidget *parent)
    : QWidget(parent)
{
    setBackgroundRole(QPalette::Base);
    setAutoFillBackground(true);
	
//	QTimer *timer = new QTimer(this);
//	connect(timer, SIGNAL(timeout()), this, SLOT(update()));
//	timer->start(10);  // 10 msec
}

QSize RenderArea::minimumSizeHint() const
{
    return QSize(600, 400);
}

QSize RenderArea::sizeHint() const
{
    return QSize(600, 400);
}

void RenderArea::setPen(const QPen &pen)
{
    this->pen = pen;
    update();
}

void RenderArea::setBrush(const QBrush &brush)
{
    this->brush = brush;
    update();
}


void RenderArea::paintEvent(QPaintEvent * /* event */)
{
	extern unsigned short m_NrPixels;
    extern double m_pLambda[MAX_NR_PIXELS];
    extern double l_pSpectrum[MAX_NR_PIXELS];
		
	QPoint points[MAX_NR_PIXELS];

	for (int teller=0;teller<m_NrPixels;++teller) {
		points[teller]=QPoint(int(m_pLambda[teller]),int(16384 - l_pSpectrum[teller]));
	}

    QPainter painter(this);
    painter.setPen(pen);
    painter.setBrush(brush);
	// vb 1100 nm wordt 600 pixels en 16384 counts wordt 400 pixels 
	painter.scale(600.0/1100.0, 400.0/16384.0);
    painter.drawPolyline(points, m_NrPixels);
    painter.setPen(palette().dark().color());
    painter.setBrush(Qt::NoBrush);
    QRect rect(0, 0, 1100, 16384);
 	painter.drawRect(rect);
}

// void RenderArea::timerEvent(QTimerEvent * event)
// {
// 	update();
// }
